#include "rheolef.h"
using namespace rheolef;
using namespace std;
#include "cosinusprod_laplace.icc"
int main(int argc, char**argv) {
  environment rheolef(argc, argv);
  geo omega (argv[1]);
  size_t d = omega.dimension();
  space Xh (omega, argv[2]);
  form a  (Xh, Xh, "grad_grad");
  form ab (Xh, Xh, "mass", omega["boundary"]);
  a = a + ab;
  field lh = riesz(Xh, f(d)) + riesz(Xh, g(d), "boundary");
  field uh (Xh);
  solver sa (a.uu());
  uh.set_u() = sa.solve (lh.u() - a.ub()*uh.b());
  dout << uh;
}
